#<profile4xi profile = "10" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "cpu_corecount4xi.py">
#<abstract4xi abstract = "returns the number of CPU cores "/>
#<refer4xi reference = "process4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------


#
# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'cpu_corecount4xi', 'sense_function4xi', 'reason_function4xi', 'ace_function4xi'] 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass    
#"
#/>


# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from constant_system4xi import ConstantSystem4Xi
from print4xi import print4xi
from time4xi import time4xi
#"
#/>

# ---------------------------------------------------------------------------------------------
#<function4xi function = "sense-function4xi-of-cpu-corecount4xi" usage = "
# senses function objects
#"> 
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
# ---------------------------------------------------------------------------------------------
def sense_function4xi(function):
    '''
    senses function objects
    '''
    
    # -----------------------------------------------------------------------------------------
    # 
    # ----------------------------------------------------------------------------------------- 
          
    class2print = 'sense_function4xi'
    method2print = 'sense_function4xi'
    
    message2print = "{started" + "; sense-function4xi-of-cpu-corecount4xi-started: " + str(sense_function4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)     
    
    message2print = "{passed" + "; function-passed-to-sense-function4xi-of-cpu-corecount4xi: " + str(function) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    
    
    # -----------------------------------------------------------------------------------------
    # initialize knowledge
    # -----------------------------------------------------------------------------------------        
    kb2xi = {'function2xi': str(function)}
             
    message2print = "{set" + "; kb2xi-set-by-sense-function4xi-of-cpu-corecount4xi to: " + str(kb2xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    
    # -----------------------------------------------------------------------------------------
    # sense knowledge specific to this function
    # -----------------------------------------------------------------------------------------         
    kb2xi['process-id2xi'] = os.getpid() 
    
    dict2xi = {}
    key2dict = 0

    
    message2print = "{set" + "; dict2xi-set-by-sense-function4xi-of-cpu-corecount4xi to: " + str(dict2xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)      
    
    message2print = "{set" + "; key2dict-set-by-sense-function4xi-of-cpu-corecount4xi to: " + str(key2dict)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)             
    
    for time2xi in os.times():

    
        # -----------------------------------------------------------------------------------------
        # 
        # ----------------------------------------------------------------------------------------- 
             
        dict2xi[key2dict] = str(time2xi) # (user-time, system-time, children-user-time, children-system-time, elapsed-time)     
        
        message2print = "{set" + "; dict2xi-element-set-by-sense-function4xi-of-cpu-corecount4xi to: " + str(dict2xi[key2dict])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        
        key2dict = key2dict + 1
       
        message2print = "{set" + "; key2dict-set-by-sense-function4xi-of-cpu-corecount4xi to: " + str(key2dict)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)              
    
    # -----------------------------------------------------------------------------------------
    # 
    # ----------------------------------------------------------------------------------------- 
         
    keys2dict = sorted(dict2xi.keys())
    
    for key2dict in keys2dict:
    
        # -----------------------------------------------------------------------------------------
        # 
        # ----------------------------------------------------------------------------------------- 
             
        message2print = "{sorted" + "; key2dict-sorted-by-sense-function4xi-of-cpu-corecount4xi: " + str(key2dict)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
    
    
        value2kb = str(dict2xi[key2dict])
        
        message2print = "{decided" + "; value2kb-decided-by-sense-function4xi-of-cpu-corecount4xi to: " + str(value2kb)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)           
        
        namekey2xi = "unresolvedname"
        if key2dict == 0:
            namekey2xi = "user-time"
        if key2dict == 1:    
            namekey2xi = "system-time"
        if key2dict == 2:    
            namekey2xi = "children-user-time"
        if key2dict == 3:
            namekey2xi = "children-system-time"
        if key2dict == 4:
            namekey2xi = "elapsed-time"  
            
        message2print = "{used" + "; namekey2xi-used-by-sense-function4xi-of-cpu-corecount4xi: " + str(namekey2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        
        kb2xi[namekey2xi] = value2kb 
        
        message2print = "{added" + "; kb2xi-element-set-by-sense-function4xi-of-cpu-corecount4xi: " + str(kb2xi[namekey2xi])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
    
        message2print = "{upgraded" + "; kb2xi-upgraded-by-sense-function4xi-of-cpu-corecount4xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 

     
         
    # -----------------------------------------------------------------------------------------
    # 
    # ----------------------------------------------------------------------------------------- 
            
    message2print = "{sensed" + "; function-sensed-by-sense-function4xi-of-cpu-corecount4xi: "  + str(function) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
     
  
    message2print = "{returning" + "; kb2xi-of-returning-by-sense-function4xi-of-cpu-corecount4xi: " + str(kb2xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)          
    # kb2xi-of-returning-by-sense-function4xi-of-cpu-corecount4xi: 
    # {'user-time': '0.1248008', 'children-user-time': '0.0', 'elapsed-time': '0.0', 'children-system-time': '0.0', 
    #  'process-id2xi': 1700, 'system-time': '0.0624004', 'self2xi': '<function main at 0x0281ADB0>'}; time: 20:12:59 12/05/09 FLE Standard Time}

   
          
    return kb2xi
    
    # -----------------------------------------------------------------------------------------
    #
    # -----------------------------------------------------------------------------------------        
#</function4xi> 

 
        
# ---------------------------------------------------------------------------------------------
#<function4xi function = "reason-function4xi-of-cpu-corecount4xi" usage = "
# reasons function objects
#"> 
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
# ---------------------------------------------------------------------------------------------
def reason_function4xi(function):
    '''
    reasons function objects
    '''
    
    # -----------------------------------------------------------------------------------------
    # 
    # ----------------------------------------------------------------------------------------- 
             
    class2print = 'reason_function4xi'
    method2print = 'reason_function4xi'
    
    message2print = "{started" + "; reason-function4xi-of-cpu-corecount4xi-started: " + str(reason_function4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)     
    
    message2print = "{passed" + "; function-passed-to-reason-function4xi-of-cpu-corecount4xi: " + str(function) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
       
    
    # -----------------------------------------------------------------------------------------
    # initialize knowledge
    # -----------------------------------------------------------------------------------------         
    kb4xi = sense_function4xi(reason_function4xi)
    
    
    message2print = "{set" + "; kb4xi-set-by-reason-function4xi-of-cpu-corecount4xi to: " + str(kb4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    
    # -----------------------------------------------------------------------------------------
    # reason knowledge specific to this function
    # -----------------------------------------------------------------------------------------          

      
    # -----------------------------------------------------------------------------------------
    #
    # -----------------------------------------------------------------------------------------        
    message2print = "{reasoned" + "; function-reasoned-by-reason-function4xi-of-cpu-corecount4xi: "  + str(function) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
  
      
         
    message2print = "{returning" + "; kb4xi-of-returning-by-reason-function4xi-of-cpu-corecount4xi: " + str(kb4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)           
    # {'self4xi': '<function main at 0x029F2DF8>'}; time: 16:53:06 12/05/09 FLE Standard Time}            
      
    return kb4xi
    
    # -----------------------------------------------------------------------------------------
    #
    # -----------------------------------------------------------------------------------------            
#</function4xi> 

  
# ---------------------------------------------------------------------------------------------
#<function4xi function = "ace-function4xi-of-cpu-corecount4xi" usage = "
#   aces function objects
#"> 
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
# ---------------------------------------------------------------------------------------------
def ace_function4xi(function):
    '''
    aces function objects 
    '''
    
    # -----------------------------------------------------------------------------------------
    # 
    # ----------------------------------------------------------------------------------------- 
    class2print = 'ace_function4xi'
    method2print = 'ace_function4xi'
    
    message2print = "{started" + "; ace-function4xi-of-cpu-corecount4xi-started: " + str(ace_function4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)            
  
    message2print = "{passed" + "; function-passed-to-ace-function4xi-of-cpu-corecount4xi: " + str(function) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)     
    
    
    # -----------------------------------------------------------------------------------------
    # initialize knowledge
    # -----------------------------------------------------------------------------------------        
    kb8xi = reason_function4xi(ace_function4xi)
 
    
    message2print = "{set" + "; kb8xi-set-by-ace-function4xi-of-cpu-corecount4xi to: " + str(kb8xi)  + "; time: " + time4xi() + "}"
    
    # -----------------------------------------------------------------------------------------
    # ace knowledge specific to this function
    # -----------------------------------------------------------------------------------------              
      
    message2print = "{aced" + "; function-aced-by-ace-function4xi-of-cpu-corecount4xi: "  + str(function) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)          
    
    # -----------------------------------------------------------------------------------------
    #
    # -----------------------------------------------------------------------------------------        
  
    message2print = "{returning" + "; kb8xi-of-returning-by-ace-function4xi-of-cpu-corecount4xi: " + str(kb8xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
             
    
    return kb8xi
    
    # -----------------------------------------------------------------------------------------
    #
    # -----------------------------------------------------------------------------------------        
#</function4xi> 

 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "cpu-corecount4xi" usage = "
# returns the number of CPUs in the system
#">                           
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def cpu_corecount4xi():
    '''
    cpu_count4xi function: returns the number of CPUs in the system
    '''
                
    # ---------------------------------------------------------------------------------------------    
    # (Step 1/4)
    # ---------------------------------------------------------------------------------------------   
    class2print = "cpu_corecount4xi"
    method2print = "cpu_corecount4xi"
    
    message2print = "{(Step 1/4) started" + "; cpu-corecount4xi-started: " + str(cpu_corecount4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)           
    # <function cpu_corecount4xi at 0x000000000321AF28>; time: 00:27:32 02/12/13 Pacific Standard Time
    
    # ---------------------------------------------------------------------------------------------    
    # (Step 2/4)
    # --------------------------------------------------------------------------------------------- 
      
    system2xi = ConstantSystem4Xi()
    
    message2print = "{(Step 2/4) set" + "; system2xi-set-by-cpu-corecount4xi to: " + str(system2xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    # <constant_system4xi.ConstantSystem4Xi object at 0x0000000002DAED68>
           
    
    # ---------------------------------------------------------------------------------------------    
    # (Step 3/4)
    # --------------------------------------------------------------------------------------------- 
            
    if sys.platform == system2xi.get_windows():                                 #'win32' dragonized
    
        # -----------------------------------------------------------------------------------------    
        #
        # ----------------------------------------------------------------------------------------- 
         
        message2print = "{(Step 3/4a1) decided" + "; system-platform-decided-by-cpu-corecount4xi: Windows" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # Windows
            
        try:
            corecount2xi = int(os.environ['NUMBER_OF_PROCESSORS'])
            
            message2print = "{(Step 3/4a2) set" + "; corecount2xi-set-by-cpu-corecount4xi to: " + str(corecount2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # 4
                    
        except (ValueError, KeyError) as e2xi:
            corecount2xi = 0
            
            message2print = "{(Step 3/4a3) hit" + "; exception-hit-by-cpu-corecount4xi: " + " *** " +  str(e2xi) + " *** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
                    
    elif sys.platform == 'darwin':
    
        # -----------------------------------------------------------------------------------------    
        #
        # ----------------------------------------------------------------------------------------- 
         
        message2print = "{(Step 3/4b1) decided" + "; system-platform-decided-by-cpu-corecount4xi: Darwin" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
             
        try:
            corecount2xi = int(os.popen('sysctl -n hw.ncpu').read())
            
            message2print = "{(Step 3/4b2) set" + "; corecount2xi-set-by-cpu-corecount4xi to: " + str(corecount2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
              
        except ValueError as e2xi:
            corecount2xi = 0
            
            message2print = "{(Step 3/4b3) hit" + "; exception-hit-by-cpu-corecount4xi: " + " *** " +  str(e2xi) + " *** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
               
    else:
    
        # -----------------------------------------------------------------------------------------    
        #
        # ----------------------------------------------------------------------------------------- 
         
        message2print = "{(Step 3/4c1) decided" + "; system-platform-decided-by-cpu-corecount4xi: Abstract" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
              
        try:
            corecount2xi = os.sysconf('SC_NPROCESSORS_ONLN')
            
            message2print = "{(Step 3/4c2) set" + "; corecount2xi-set-by-cpu-corecount4xi to: " + str(corecount2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
              
            
        except (ValueError, OSError, AttributeError) as e2xi:
            corecount2xi = 0
   
            message2print = "{(Step 3/4c3) hit" + "; exception-hit-by-cpu-corecount4xi: " + " *** " +  str(e2xi) + " *** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
       
    # ---------------------------------------------------------------------------------------------    
    # (Step 4/4)
    # --------------------------------------------------------------------------------------------- 
    
    if corecount2xi >= 1:
        
        pass
    else:
    
        # -----------------------------------------------------------------------------------------    
        # yield and set a reasonable value 
        # ----------------------------------------------------------------------------------------- 
        corecount2xi = 1 
        
        message2print = "{(Step 4/4b) yielded" + "; corecount2xi-yielded-by-cpu-corecount4xi: " + str(corecount2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 

      
    message2print = "{(Step 4/4a) returning" + "; corecount2xi-returning-by-cpu-corecount4xi: " + str(corecount2xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
    # 4
            
    return corecount2xi
    
#</function4xi> 
#</program4xi> 

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_cpu_corecount4xi.txt
#   sense-test-cpu-corecount4xi.xml
#   reason-test-cpu-corecount4xi.xml
#   ace-test-cpu-corecount4xi.xml
#"
#>


# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

    
    

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of cpu_corecount4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>


